local T = ZZT_ZombieTag



--
T.EggPlayerThink = function(player)
	local mo = player.mo
	if not (mo and mo.valid) then return end
	if not T.isInGamemode() then return end

	if player.ert_buttonhistory == nil then
		player.ert_buttonhistory = player.cmd.buttons
	end

	local abilities = T.getZTAbilityData(player)
	if not abilities then return end

	local runnerData = abilities.runner
	local taggerData = abilities.tagger

	local buttons = player.cmd.buttons
	local oldbuttons = player.ert_buttonhistory

	local runnerPressed = (buttons & BT_FIRENORMAL) ~= 0 and (oldbuttons & BT_FIRENORMAL) == 0
	local taggerPressed = (buttons & BT_ATTACK) ~= 0 and (oldbuttons & BT_ATTACK) == 0

	-- Initialize cooldowns if needed
	player.zzt_runnerCooldown = $ or 0
	player.zzt_taggerCooldown = $ or 0

	local function canUse(data, cooldown)
		return data and cooldown == 0 and player.rings >= data.ringCost
	end

	local function useAbility(data, cooldownField)
		if not data then return end
		data.func(player)
		player.rings = player.rings - data.ringCost
		player[ cooldownField ] = data.cooldown
	end

	if runnerPressed and canUse(runnerData, player.zzt_runnerCooldown) then
		useAbility(runnerData, "zzt_runnerCooldown")
	elseif taggerPressed and canUse(taggerData, player.zzt_taggerCooldown) then
		useAbility(taggerData, "zzt_taggerCooldown")
	end

	-- Tick down both cooldowns
	if player.zzt_runnerCooldown > 0 then
		player.zzt_runnerCooldown = $ - 1
	end
	if player.zzt_taggerCooldown > 0 then
		player.zzt_taggerCooldown = $ - 1
	end

	-- Debug override
	if T.NoCooldown == 1 then
		player.zzt_runnerCooldown = 0
		player.zzt_taggerCooldown = 0
	end

	player.ert_buttonhistory = buttons
end



addHook("PostThinkFrame",do
	for player in players.iterate
		player.ert_buttonhistory = player.cmd.buttons
	end
end)

 






