local T = ZZT_ZombieTag

T.EnderPearl = function(player)
				local mo = player.mo
				local skygem = P_SPMAngle(mo, MT_SKYGEMTP, mo.angle, 1)
				if skygem then
					skygem.thrower = mo
					skygem.fuse = 200
					S_StartSound(mo, sfx_wepfir)
					local trail = P_SpawnGhostMobj(mo)
					trail.sprite2 = trail.sprite2|FF_FULLBRIGHT
					trail.color = SKINCOLOR_CYAN
					trail.colorized = true
					trail.fuse = 2
				end
end

function A_SkyGemTeleport(skygem, var1, var2)
	if skygem and skygem.valid then
		if skygem.fuse <= 1 then
			return
		end
	end
	local mo = skygem.thrower
	if mo and mo.valid then
		if mo.player and mo.player.valid then
				P_SetOrigin(mo, skygem.x, skygem.y, skygem.z)
				S_StartSound(mo, sfx_s3kb3)
		end
	end
end

addHook("MobjThinker", function(skygem)
	if skygem and skygem.valid then
		if not skygem.rotateangle then
			skygem.rotateangle = P_RandomRange(-4,4)*FRACUNIT
		end
		if not skygem.lifetime then
			skygem.lifetime = 0
		end
		skygem.lifetime = $ + 1
		if skygem.lifetime > 2 then
			skygem.flags = $ & ~MF_NOGRAVITY
		end
		skygem.rollangle = $ + skygem.rotateangle
		
		local trail = P_SpawnGhostMobj(skygem)
		trail.fuse = 8
	end
end, MT_SKYGEMTP)

addHook("ShouldDamage", function(target, inflictor)
	if target and target.valid and inflictor and inflictor.valid and inflictor.type == MT_SKYGEMTP then
		return false
	end
end)
