local T = ZZT_ZombieTag

T.SwapPositions = function(player)
	if not player.mo then return end
	player.powers[pw_invulnerability] = TICRATE/4
	local closest
	local closestdist = nil

	for other in players.iterate do
		if other == player then continue end
		if not other.mo then continue end
		if other.spectator then continue end

		local dist = R_PointToDist2(player.mo.x, player.mo.y, other.mo.x, other.mo.y)

		if not closestdist or dist < closestdist then
			closest = other
			closestdist = dist
		end
	end

	if closest and closest.mo then
		-- Swap position
		local px, py, pz = player.mo.x, player.mo.y, player.mo.z
		local ox, oy, oz = closest.mo.x, closest.mo.y, closest.mo.z

		P_SetOrigin(player.mo, ox, oy, oz)
		P_SetOrigin(closest.mo, px, py, pz)

		S_StartSound(player.mo, sfx_clap)
		S_StartSound(closest.mo, sfx_clap)
	end
end
