local T = ZZT_ZombieTag

T.PanicButton = function(player)
	if not player or not player.valid then return end
	local mo = player.mo
	if not mo or not mo.valid then return end

	local PULL_RADIUS = 256*FRACUNIT
	local KNOCK_STRENGTH = 12*FRACUNIT

	for other in players.iterate do
		if not other.valid or not other.mo or other.spectator then continue end
		if not T.isIt(other) then continue end -- Only affect taggers

		local dist = R_PointToDist2(mo.x, mo.y, other.mo.x, other.mo.y)
		if dist > PULL_RADIUS then continue end

		local angle = R_PointToAngle2(other.mo.x, other.mo.y, mo.x, mo.y)
		other.mo.momx = $ + FixedMul(cos(angle), KNOCK_STRENGTH)
		other.mo.momy = $ + FixedMul(sin(angle), KNOCK_STRENGTH)

		-- Optional: small visual indicator
		P_SpawnMobjFromMobj(other.mo, 0, 0, 0, MT_THOK)
		P_DoPlayerPain(other)
	end

	-- Optional: Sound & smoke puff
	S_StartSound(mo, sfx_thok)
	T.SpawnRingExplosion(mo.x, mo.y, mo.z + 20*FRACUNIT)
end

T.SpawnRingExplosion = function(x, y, z)
	for i = 0, 15 do
		local angle = ANGLE_45 * i
		local thok = P_SpawnMobj(x, y, z, MT_THOK)
		thok.momx = FixedMul(cos(angle), 6*FRACUNIT)
		thok.momy = FixedMul(sin(angle), 6*FRACUNIT)
		thok.tics = 10
	end
end