local T = ZZT_ZombieTag

T.StartBlackHole = function(player)
player.zzt_pullActive = 10*TICRATE
end

local PULL_RADIUS = 256*FRACUNIT
local PULL_FORCE = 2*FRACUNIT
T.BlackHole = function(player)
	if not player.mo then return end
	if not T.isIt(player) then return end -- only taggers can use this

	for other in players.iterate do
		if other == player or not other.mo or not other.mo.valid then continue end
		if T.isIt(other) then continue end -- skip taggers, only pull runners

		local dist = R_PointToDist2(player.mo.x, player.mo.y, other.mo.x, other.mo.y)
		if dist <= PULL_RADIUS then
			local angle = R_PointToAngle2(other.mo.x, other.mo.y, player.mo.x, player.mo.y)

			-- Apply small pull toward the tagger each frame
			other.mo.momx = $ + FixedMul(cos(angle), PULL_FORCE)
			other.mo.momy = $ + FixedMul(sin(angle), PULL_FORCE)
		end
	end
end

T.BlackHoleThink = function(player)
	if player.zzt_pullActive and player.zzt_pullActive > 0 then
			T.BlackHole(player)
			player.zzt_pullActive = $ - 1
	end
end