local T = ZZT_ZombieTag

T.checkIndex = function(player)
	if not player or not player.valid then return end

	player.zzt_roleSelect = player.zzt_roleSelect or "runner"
	player.zzt_abilityIndex = player.zzt_abilityIndex or 1

	local role = player.zzt_roleSelect
	if role == "runner" and player.zzt_storerunability and T.ZT_Abilities.runner[player.zzt_storerunability] then
		player.zzt_abilityIndex = player.zzt_storerunability
	elseif role == "tagger" and player.zzt_storezomability and T.ZT_Abilities.tagger[player.zzt_storezomability] then
		player.zzt_abilityIndex = player.zzt_storezomability
	else
		player.zzt_abilityIndex = 1
	end
end



T.SaveDefault = function(player)
	if not player then return end

	player.zzt_abilityIndex = $ or 1
	player.zzt_abilityCD = {}
	player.zzt_abilitySwapDelay = 0
	player.zzt_roleSelect = player.zzt_roleSelect or "runner" -- Default shown abilities

	local abilityList = T.ZT_Abilities[player.zzt_roleSelect]
	for i = 1, #abilityList
		player.zzt_abilityCD[i] = 0
	end
end





T.HudSelect = function()
	for player in players.iterate do
		if not player.mo or not T.isInGamemode() then continue end
		local allowedTime = 15 * TICRATE
		if leveltime > allowedTime then return end

		T.loadFile()

		if player.zzt_abilitySwapDelay and player.zzt_abilitySwapDelay > 0 then
			player.zzt_abilitySwapDelay = player.zzt_abilitySwapDelay - 1
		end

		local role = player.zzt_roleSelect or "runner"
		local list = T.ZT_Abilities[role]
		if not list then continue end

		local max = #list
		if max == 0 then continue end

		local buttons = player.cmd.buttons

		if buttons & BT_WEAPONNEXT ~= 0 and (not player.zzt_abilitySwapDelay or player.zzt_abilitySwapDelay == 0) then
			player.zzt_abilityIndex = ((player.zzt_abilityIndex or 0) % max) + 1
			player.zzt_abilitySwapDelay = 10
			S_StartSound(nil, sfx_menu1, player)
		elseif buttons & BT_WEAPONPREV ~= 0 and (not player.zzt_abilitySwapDelay or player.zzt_abilitySwapDelay == 0) then
			player.zzt_abilityIndex = (((player.zzt_abilityIndex or 1) - 2 + max) % max) + 1
			player.zzt_abilitySwapDelay = 10
			S_StartSound(nil, sfx_menu1, player)
		elseif buttons & BT_TOSSFLAG ~= 0 and (not player.zzt_abilitySwapDelay or player.zzt_abilitySwapDelay == 0) then
			player.zzt_roleSelect = (role == "runner") and "tagger" or "runner"

			local storedIndex
			if player.zzt_roleSelect == "runner" then
				storedIndex = player.zzt_storerunability
			else
				storedIndex = player.zzt_storezomability
			end

			-- Validate storedIndex against ability list size
			local abilityList = T.ZT_Abilities[player.zzt_roleSelect]
			if storedIndex and abilityList and storedIndex >= 1 and storedIndex <= #abilityList then
				player.zzt_abilityIndex = storedIndex
			else
				player.zzt_abilityIndex = 1
			end

			S_StartSound(nil, sfx_sele, player)
			player.zzt_abilitySwapDelay = 15
		end

		local role = player.zzt_roleSelect or "runner"
		if role == "runner" then
			player.zzt_storerunability = player.zzt_abilityIndex
		elseif role == "tagger" then
			player.zzt_storezomability = player.zzt_abilityIndex
		end
	end
end