local T = ZZT_ZombieTag
local gfx_IT = "TAGICO"
local gfx_frz = "CHAOS4"
local gfx_sfrz = "CHAOS3"

local function drawItIcon(g,x,y,s)
	local IT = g.cachePatch(gfx_IT)
	g.drawScaled(x*FRACUNIT, y*FRACUNIT, s/2, IT)
end
local function drawFrzIcon(g,x,y,s)
	local FRZ = g.cachePatch(gfx_frz)
	g.drawScaled(x*FRACUNIT, y*FRACUNIT, s, FRZ, V_30TRANS)
end

hud.add(function(g)
	if not T.isInGamemode() then return end
	
	local playerlist = {}
	local c=0
	local p=0 --Seperate counter that counts all players. The score screen actually uses this value.
	for pl in players.iterate do
		p=p+1
		if pl.spectator then continue end
		table.insert(playerlist,{c,pl})
		c=c+1
	end
	table.sort(playerlist,function(a,b)
		return (a[2].score*32)+a[1] > (b[2].score*32)+b[1]
	end)
	
	--TAB Screen splits above 9 players.
	--At 21 players, the screen converts into 32-player version.
       
	local xo = 24
	local yo = 28
	if p > 9 then xo=16 end
	if p > 20 then xo=6 end
	local wrap = 9
	local wrdist = 16
	local scale = FRACUNIT
	if p > 20 then wrap=17 wrdist=9 scale=FRACUNIT/2 end
	for i=1,#playerlist do
		local pl2=playerlist[i][2]
		
		local x=(i-1)/wrap
		local y=(i-1)%wrap

		if i == wrap+1 and p > 20 then yo=yo+4 end
		
		if T.isIt(pl2) and T.zzt_mod_disguised == false then
			drawItIcon(g,xo+(x*160), yo+(y*wrdist),scale)
		end
		if T.isFrozen(pl2) then
			drawFrzIcon(g,xo+(x*160)+wrdist, yo+(y*wrdist),scale)
		end
	end
       
end, "scores")

hud.add(function(v, player, cam)
if not T.isInGamemode() then return end
	if not player or not player.valid then return end
	if not player.zzt_hudMsg or not player.zzt_hudMsgTime then return end
	local flags = V_PERPLAYER

	if leveltime < player.zzt_hudMsgTime then
		v.drawString(160, 100, player.zzt_hudMsg, V_ALLOWLOWERCASE|flags, "center")
	end
end, "game")

