local abilitysave = "client/ZombieTag/abilitysave.dat"
local T = ZZT_ZombieTag

T.saveAllCommands = function(player)
    if not player or not player.valid then return end

    local tagger = tonumber(player.zzt_storezomability or 0)
    local runner = tonumber(player.zzt_storerunability or 0)

    if not tagger or not runner then
        CONS_Printf(player, "Failed to save abilities: missing values.")
        return
    end

    -- Skip writing if no changes
    local last = player.zzt_lastSave or {}
    if last.tagger == tagger and last.runner == runner then return end

    local file = io.openlocal(abilitysave, "w+")
    if file then
        file:write(
            "taggerability " .. tagger .. "\n" ..
            "runnerability " .. runner .. "\n"
        )
        file:close()

        player.zzt_lastSave = {
            tagger = tagger,
            runner = runner
        }
    else
        CONS_Printf(player, "Error saving abilities.")
    end
end




T.loadFile = function(p)
    if p == consoleplayer and T.isInGamemode() then
        if not p.zzt_loadedAbilities then -- only run once
            local file = io.openlocal(abilitysave, "r")
            if file then
                for line in file:lines() do
                    if line ~= "" then
                        COM_BufInsertText(p, line)
                    end
                end
                file:close()
            else
                -- fallback defaults
                COM_BufInsertText(p, "taggerability 1")
                COM_BufInsertText(p, "runnerability 1")
            end
            p.zzt_loadedAbilities = true -- mark as loaded
        end
    end
end