local T = ZZT_ZombieTag

addHook("ThinkFrame", function()
	if not T.isInGamemode() then return end

	for tagger in players.iterate do
		if not (tagger.mo and tagger.zzt_isIt) then continue end
		local hand = tagger.zzt_tagHand
		if not (hand and hand.valid) then continue end

		for target in players.iterate do
			if target == tagger or not (target.mo and target.mo.valid) then continue end
			if target.zzt_isIt then continue end
			if target.powers[pw_invulnerability] > 0 or tagger.powers[pw_invulnerability] > 0 then continue end

			local dist2 = R_PointToDist2(hand.x, hand.y, target.mo.x, target.mo.y)
			local dz = hand.z - target.mo.z
			if dz < 0 then dz = -dz end

			if dist2 <= (hand.radius + target.mo.radius)
			and dz < (hand.height + target.mo.height)
			then
				T.DoTag(tagger, target)
				break -- Only tag one target per frame
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if not T.isInGamemode() then return end
	if not player.mo or not player.valid then return end
	if player.spectator then return end

	local gm = T.zzt_gamemode

	-- Only care about runners (not It/frozen)
	if T.isIt(player) or (gm == "freeze" and T.isFrozen(player)) then return end

	-- Check if the player is "dead"
	if player.mo.health <= 0 then
		if gm == "zombie" then
			player.zzt_isIt = true
			T.ShowHUDMessage(player, "\x85You've been infected!", 2*TICRATE)
			S_StartSound(nil, sfx_s3k56, player)
			T.CheckRoundEnd()
		elseif gm == "freeze" then
			T.doFreeze(player, player) -- Freezes self
			T.CheckRoundEnd()
		elseif gm == "crown" then
			T.TransferRunnerOnDeath(player)
		elseif gm == "tag" then
			T.TransferRunnerOnDeath(player)
		end
	end
end)

--Score Increaser
addHook("ThinkFrame", function()
if not T.isInGamemode() then return end
if T.zzt_gamemode == nil then return end
if T.zzt_gamemode == "bomb" then return end
if T.zzt_gamemode == "juggernaut" then return end
	for player in players.iterate do
		if not player.mo or not player.valid then continue end

		-- Don't reward points if player is "It"
		if T.isIt(player) then continue end
		if T.isFrozen(player) or T.isSuperFrozen(player) then continue end
		-- Initialize timer if needed
		if not player.zzt_scoreTimer then
			player.zzt_scoreTimer = 0
		end

		-- Increment timer
		player.zzt_scoreTimer = $ + 1

		-- Once per second
		if player.zzt_scoreTimer >= TICRATE then
			player.score = $ + 1 -- Add to scoreboard
			player.zzt_scoreTimer = 0 -- Reset timer
		end
	end
end)
