
//Variables
local radar=1
local radarhalf=0
local radarwarn=0
local radarscale=(45*FRACUNIT)
local timeclose = 30*TICRATE
local hadsuper = 0
local color_it = 35
local color_runner = 150
local offsetx=8
local offsety=128
local framecolor=3
	local timer = 0
	local sound = 0
	local yaboi = 1


local function isInGamemode()
	return gametype == GT_ZOMBIETAG
end

CV_RegisterVar({name="ZT_RADAR",defaultvalue="On",
	flags=CV_CALL|CV_NOINIT|CV_SHOWMODIF,
	PossibleValue={Off=0,On=1},
	func=function(cv)
		radar=cv.value
	end
})

CV_RegisterVar({name="ZT_HALF",defaultvalue="Off",
	flags=CV_CALL|CV_NOINIT|CV_SHOWMODIF,
	PossibleValue={Off=0,On=1},
	func=function(cv)
		radarhalf=cv.value
	end
})


local supertimer = 1

CV_RegisterVar({name="ZT_SUPERTIMER",defaultvalue="1",
	flags=CV_CALL|CV_NETVAR|CV_NOINIT|CV_SHOWMODIF,
	PossibleValue={MIN = 0, MAX = 30000},
	func=function(cv)
		supertimer=cv.value
	end
})



--L_FreezeTag_v4.lua code cause I'm not writing a radar code :)
//https://mb.srb2.org/addons/freeze-tag.3179/
//


--[[Gamemode Constants]]

local function isPlayerActive(pl)
	return pl.mo and not pl.spectator
end
local function isIt(pl)
	return pl.pflags & PF_TAGIT
end
local function countPlayers()
	local count,it=0,0,0
	for pl in players.iterate
		if pl.spectator then continue end
		
		if isIt(pl) then it=$+1 end
		count=count+1
	end
	return count,it
end

local function isInGamemode()
	return gametype == GT_ZOMBIETAG
end







--[[HUD]]
local function drawHeader(g,pl)
	
	--[[Timer]]
	if not isInGamemode () then return end
		local color
		
		local gametime=((timelimit*60*TICRATE))
		

			if radarhalf == 1
				if (leveltime>=((gametime/2)+(15)))
					radar = 1
				else 
					radar = 0 
				end
			end
		
		
		
		
		if (leveltime/TICRATE)<=15
			if not isIt(pl)
			g.drawString(160,0, "GO", color or V_YELLOWMAP, "center")
			g.drawString(160,8, "HIDE", color, "center")
			g.drawString(160,16, tostring((15-(leveltime/TICRATE))), V_REDMAP, "center")
			elseif isIt(pl)
			g.drawString(160,0, "FIND", V_GREENMAP, "center")
			g.drawString(160,8, "THEM", V_GREENMAP, "center")
			g.drawString(160,16, tostring((15-(leveltime/TICRATE))), V_REDMAP, "center")
			end
		else
		g.drawString(160,0, "Time:", color or V_YELLOWMAP, "center")
		g.drawString(160,8, tostring(15+((gametime-leveltime)/TICRATE)), color, "center")
		end
		
end

local function drawTooltips(g,pl)
	local i=0
	
	for k,v in pairs(tooltips["general"]) do
		drawTooltip(g,pl,i,v)
		i=i+1
	end

	local state = "idle"
	if leveltime > 0 then
		if isIt(pl) then
			state = "it"
		end
		if not isIt(pl) then
			state = "runner"
		end
		
	end
	for k,v in pairs(tooltips[state]) do
		drawTooltip(g,pl,i,v)
		i=i+1
	end
end


-- [[Radar+Hud]]
hud.add(function(g,pl,cam)
	if not isInGamemode() then return end
	if pl.playerstate == PST_LIVE then
		

	if isIt(pl)
		yaboi = 2
	else
		yaboi = 1
	end

	if hadsuper == 0
		if pl.rings*supertimer >= supertimer*30*yaboi and pl.rings >= 50
			if sound == 0
			P_PlayLivesJingle(pl)
			sound = 1
			end
			if timer<=140
				g.drawString(80,70, tostring("You have enough rings", V_YELLOWMAP, "center"))
				g.drawString(80,80, tostring("to fully utilize Super!", V_YELLOWMAP, "center"))
			timer = timer+1
			hadsuper = 1
			end
		end
	end



		
		local yo=0
		if not radar then yo=64 end
		--[[Status]]
		local str="RUNNER!"
		local c=V_BLUEMAP
		if isIt(pl) then
			str="ZOMBIE!" c=V_GREENMAP
		end

		if emeralds
		g.drawString(8,112+yo, str, c)
		elseif not emeralds
		g.drawString(8,120+yo, str, c)
		end
		
		
		local emeraldo = g.cachePatch("EMERALDO")
		
	  		--[[Rings]]	
		if emeralds then
			local c=V_WHITEMAP
			local time = nil
			if pl.rings >= 50 and not pl.powers[pw_super] then c=V_YELLOWMAP end
			
			if not pl.powers[pw_super]
			if pl.rings >= 50 then g.drawScaled(1360000, 8910000, FRACUNIT/9, emeraldo, V_HUDTRANSHALF, color) end
			end
			
			if pl.isxmomentum and pl.rings >=150 and not pl.powers[pw_super] then c=V_SKYMAP end
			
			if pl.powers[pw_super] then time=((supertimer*30*TICRATE - pl.powers[pw_super] - (pl.rings - supertimer))/TICRATE)+1 end
			
			if isIt(pl)
				if pl.powers[pw_super] then time=((2*supertimer*30*TICRATE - pl.powers[pw_super] - (pl.rings - supertimer))/TICRATE)+1 end
			end
			
			if pl.powers[pw_super] and time >= 10 then c=skincolors[pl.mo.color].chatcolor elseif pl.powers[pw_super] and time <= 10 then c=V_REDMAP end
			

					if not pl.powers[pw_super]
						g.drawString(8,120+yo, "RINGS: "+tostring(pl.rings), c)
					elseif pl.isxmomentum and pl.hyper.capable and pl.powers[pw_super]
						g.drawString(8,120+yo, "HYPER: "+tostring(time), c)
					else
						g.drawString(8,120+yo, "SUPER: "+tostring(time), c)
					end
		end
		
		

		--[[Radar]]
		if radar then
			local angle = (-cam.angle)-ANGLE_90

		
			for pl2 in players.iterate do
				if pl2.playerstate ~= PST_LIVE or not isPlayerActive(pl2) then continue end
				local ox,oy = pl2.mo.x - pl.mo.x, pl2.mo.y - pl.mo.y
				local x = -(FixedMul(ox,cos(angle))-FixedMul(oy,sin(angle)))/radarscale
				local y =  (FixedMul(ox,sin(angle))+FixedMul(oy,cos(angle)))/radarscale
				
				--Phase out surviving teammate runners or teammate taggers as unimportant information.
				if (x > 31) or (x < -31) or (y > 31) or (y < -31) then
					if not isIt(pl)
					and not isIt(pl2)
						continue
					end
					if isIt(pl) and isIt(pl2) then
						continue
					end
				end
				x = max(x,-31)
				x = min(x,31)
				y = max(y,-31)
				y = min(y,31)

				local blink = leveltime % 4 == 0
				local color = color_unassigned
				if not isIt(pl2) and leveltime > 0 then
					color = color_runner
		
					if isIt(pl) then
						framecolor = color_runner
					end
				end
				if isIt(pl2) then
					color = color_it
					if not isIt(pl) then
						if blink then
							color = color_itblink
						end
						framecolor = color_it
					end
				end
				g.drawFill(offsetx+30+x,offsety+30+y,4,4,color)
			end
		
			if not radarwarn then framecolor = 3 end
			
			g.drawFill(offsetx, offsety,	64,1,framecolor)
			g.drawFill(offsetx, offsety+63,	64,1,framecolor)
			g.drawFill(offsetx, offsety,	1,64,framecolor)
			g.drawFill(offsetx+63, offsety,	1,64,framecolor)
		end

		drawHeader(g,pl)
       	if guide == 1 then 
			drawTooltips(g,pl)
		end
		if guide == 2 then
			drawWelcome(g,pl)
		end
	end
end, "game")



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



local function isPlayerActive(pl)
	return pl.mo and not pl.spectator
end

local function isIt(pl)
	return pl.pflags & PF_TAGIT
end

local function countPlayers()
	local count,it=0,0,0
	for pl in players.iterate
		if pl.spectator then continue end
		
		if isIt(pl) then it=$+1 end
		count=count+1
	end
	return count,it
end

--Restrict Super time
//Code borrowed from Zoraxua's Super in Ringslinger
addHook("PlayerThink", function(pl)
	if gametype == GT_ZOMBIETAG
	//Local variables to help the game
		if pl.iwantemmymusic == nil then pl.iwantemmymusic = 0 end
		if pl.myemmymusicis == nil then pl.myemmymusicis = "_INV" end
	//Poggers

		//Now what's the requirements?
		if pl.powers[pw_super] //Don't wanna remove super mid-use
			if isIt(pl)
				if pl.powers[pw_super] == 2*supertimer*30*TICRATE
					pl.powers[pw_super] = 0 //So lose super if you've had it for too long, grr
					pl.rings = 0
					//Following ripped from SR lmao
					S_StartSound(nil, sfx_s3k9c) //Trans SFX, global so everyone knows!
					pl.mo.color = pl.skincolor //Fix supercolor
					pl.mo.state = pl.mo.state //Go back to normal if you have super sprites
					P_SpawnShieldOrb(pl) //Get the sheild back if you had one
					P_RestoreMusic(pl) //Fix music if character uses custom for soup
					timer = 0
					hadsuper = 0
					sound = 0
				end
			end
			if not isIt(pl)
				if pl.powers[pw_super] == supertimer*30*TICRATE
					pl.powers[pw_super] = 0 //So lose super if you've had it for too long, grr
					pl.rings = 0
					//Following ripped from SR lmao
					S_StartSound(nil, sfx_s3k9c) //Trans SFX, global so everyone knows!
					pl.mo.color = pl.skincolor //Fix supercolor
					pl.mo.state = pl.mo.state //Go back to normal if you have super sprites
					P_SpawnShieldOrb(pl) //Get the sheild back if you had one
					P_RestoreMusic(pl) //Fix music if character uses custom for soup
					timer = 0
					hadsuper = 0
					sound = 0
				end
			end
		end
	end
end)

